﻿@model ExploreApilkasiCuti.Models.PengajuanCuti

@{
    ViewBag.Title = "Tambah Pengajuan Cuti";
    ViewBag.IdPengajuanDtl = "";
}

@section HeadLibrary{
    <meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
    <link rel="stylesheet" href="~/AdminLTE/plugins/fontawesome-free/css/all.min.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- Toast-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css" />
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
    <!-- Google Font: Source Sans Pro -->
    @*    <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700" rel="stylesheet">
    *@    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Datepicker-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap-datepicker/css/bootstrap-datepicker.min.css">
    <!-- Tempusdominus Bootstrap 4-->
    @*<link rel="stylesheet" href="~/AdminLTE/plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">*@
}

<style>
    .help-block {
        color: red;
    }

    .has-error {
        color: red;
    }

    .bord {
        display: block;
        @*margin-top: 15px;
        padding-top: 0.35em;
        padding-bottom: 0.625em;
        padding-left: 0.75em;
        padding-right: 0.75em;
        border-style: solid;
        border-width: 2.5px;
        text-align: center;*@
    }

    .grid {
        display: grid;
        grid-column-gap: 1rem;
        grid-auto-flow: column;
        margin: 0 0 0 0;
    }

    .container {
        background: black;
        white-space: nowrap;
        overflow: scroll;
    }

        .container > div {
            background: #555;
            display: inline-block;
            margin: 10px;
        }
</style>

<div class="card">
    <div class="card-header">
        <h2 id="headerAddSeeDtl">@ViewBag.Title</h2>
    </div>
    <div class="card-body">
        <div class="col-sm-12">
            <div class="row justify-content-between">
                <a href="@Url.Action("Index", "PengajuanCuti")" class="btn btn-default">
                    <i class="nav-icon fas fa-chevron-left"></i>   Kembali
                </a>
                @*<button type="button" class="btn btn-default" onclick="add_update_data('ADD')" id="btnSubmitData">
                        <i class="nav-icon fas fa-save"></i>   Submit Data
                    </button>*@
                <div class="mt-3 col-md-12"></div>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="card card-primary card-outline card-outline-tabs">
                    <div class="card-body">
                        <!--<div class="card card-primary">-->
                        <form role="form" id="form-header">
                            <div class="card-body">
                                @*<div class="form-group" style="width:50%">
            <label class="control-label">Nama Karyawan</label>
            <input name="NamaKaryawan" placeholder="Nama Karyawan" id="NamaKaryawan" class="form-control" type="text">
            <span class="help-block"></span>
        </div>
        <div class="form-group" style="width:50%">
            <label class="control-label">Tanggal Pengajuan</label>
            <input name="TglPengajuan" placeholder="Tanggal Pengajuan" id="TglPengajuan" class="form-control" type="text">
            <span class="help-block"></span>
        </div>*@
                                @*<div class="grid" style="width:50%">*@
                                <div class="form-group" style="width:50%">
                                    <label class="err-jenisCuti control-label">Jenis Cuti</label>
                                    <select name="JenisCuti" id="JenisCuti" class="form-control select2 JenisCuti" style="width: 100%;">
                                    </select>
                                    <span id="spanJenisCuti" class="err-jenisCuti help-block"></span>
                                </div>
                                @*</div>*@
                                <!--<div class="form-group" style="width:50%">
        <label class="control-label">Lama Cuti</label>-->
                                @*<input name="LamaCuti" placeholder="Lama Cuti" id="LamaCuti" class="form-control" type="text" aria-describedby="field_hint">
        <span class="help-block"></span>
        <p id="field_hint" style="font-size:12px">Gunakan separator (.) untuk pemisah decimal agar nilai input tidak dibulatkan oleh sistem</p>*@
                                <!--<select name="LamaCutiChoice" id="LamaCutiChoice" class="form-control select2 LamaCutiChoice" style="width: 100%;">
        </select>
        <span id="spanLamaCutiChoice" class="err-lamaCutiChoice help-block"></span>
    </div>-->
                                <div class="form-inline justify-content-between" style="width:50%">
                                    <div class="form-group">
                                        <label class="control-label" style="padding-right:1em" id="labelDatepicker">Pilih Tanggal Cuti</label>
                                        <div class="input-group date form-group" id="datepicker">
                                            <input type="text" class="form-control" id="LeaveDatePicker" name="LeaveDatePicker" placeholder="Select days" hidden />
                                            @*<span class="input-group-addon"><i class="fa fa-calendar"></i><span class="count"></span></span>*@
                                            <span class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-secondary waves-effect waves-light"><i class="fa fa-calendar"></i></span>
                                        </div>
                                    </div>
                                    @*<div class="input-group date" data-target-input="nearest" id="toggleCalendar">
                <input type="text" class="form-control datetimepicker-input" id="LeaveDate" data-target="#LeaveDate" data-date-format="MM-DD-YYYY" hidden>
                <div class="input-group-append" id="LeaveDate" data-target="#LeaveDate" data-toggle="datetimepicker">
                    <div class="input-group-text" id="LeaveDate" placeholder="Pilih Tanggal Cuti"><i class="fa fa-calendar"></i></div>
                </div>
            </div>*@
                                    <div class="form-group">
                                        <label class="control-label" id="totalDurasi" style="padding-right:1em">Total Durasi</label>
                                        <input class="form-control" id="totalDurasiInput" type="text" readonly>
                                    </div>
                                    <span id="span_leave_half_day" class="help-block"></span>
                                </div>
                                <div class="form-group" style="width:50%">
                                    <label class="control-label">Keterangan</label>
                                    <textarea name="Keterangan" placeholder="Enter ..." id="Keterangan" class="form-control" type="text" rows="3"></textarea>
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group" style="width:50%">
                                    <label class="control-label">Alamat Saat Cuti</label>
                                    <textarea name="AlmSaatCuti" placeholder="Enter ..." id="AlmSaatCuti" class="form-control" type="text" rows="3"></textarea>
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group" style="width:50%">
                                    <label class="control-label">Telp. Saat Cuti</label>
                                    <input name="TelpSaatCuti" placeholder="No. Telepon" id="TelpSaatCuti" class="form-control" type="text">
                                    <span class="help-block"></span>
                                </div>
                                <div id="sendToApproval">
                                    <label class="control-label">Kirim Ke</label>
                                    <div class="form-group" style="width:50%">
                                        <label class="err-idApproval control-label">ID Approval</label>
                                        <select name="IDApproval" id="IDApproval" class="form-control select2 IDApproval" style="width: 100%;">
                                        </select>
                                        <span id="spanIdApproval" class="err-idApproval help-block"></span>
                                    </div>
                                    <div class="form-group" style="width:50%">
                                        <label class="err-idKywApproval control-label">ID Karyawan Approval</label>
                                        <select name="IDKywApproval" id="IDKywApproval" class="form-control select2 IDKywApproval" style="width: 100%;">
                                        </select>
                                        <span id="spanIdKywApproval" class="err-idKywApproval help-block"></span>
                                    </div>
                                </div>
                                <div class="form-group" style="width:52%" id="approvalDetail">
                                    <label class="control-label">History Approval</label>
                                    <!-- The timeline -->
                                    <div class="timeline timeline-inverse" id="historyApproval">
                                        <!-- timeline item -->
                                        <!--<div id="approve">
                                        <i class="fa fa-check-circle bg-success"></i>-->
                                                                        @*<i class="fa fa-times-circle bg-danger"></i>
                                            <i class="fa fa-clock bg-warning"></i>*@

                                                                        <!--<div class="timeline-item">
                                                <span class="time" id="dateApproval"><i class="far fa-calendar-check"></i>   04/06/2021</span>

                                                <h3 class="timeline-header" id="statusApproval" style="font-weight:bold">Status Approval: </h3>

                                                <div class="timeline-body">
                                                    <strong id="namaApproval" class="text-primary"> ID Approval - Nama </strong> menerima pengajuan cuti Anda
                                                </div>
                                            </div>
                                        </div>-->
                                                                        <!-- END timeline item -->
                                                                        <!--<div>
                                            <i class="fa fa-circle"></i>
                                        </div>-->
                                    </div>
                                </div>
                                <!--<label class="col-md-12" style="color:red">*Klik Tab untuk pindah field.</label>-->
                            </div>
                        </form>
                        <!--</div>-->
                    </div>
                    <div class="card-footer">
                        <button type="button" class="btn btn-default" onclick="add_update_data('ADD')" id="btnSubmitData">
                            <i class="nav-icon fas fa-save"></i>   Submit Data
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="modal_form_insertupdatedetail" role="dialog" data-keyboard="true" data-backdrop="static">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="insertUpdateDetailModal">Tambah Tanggal Cuti</h3>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            </div>
            <div class="card card-primary">
                <form role="form" id="form-insertupdatedetail">
                    <div class="card-body">
                        <div class="form-group">
                            <label>Tanggal Mulai Cuti</label>
                            <div class="input-group date" data-target-input="nearest">
                                <input type="text" class="form-control datetimepicker-input" id="StartDate" data-target="#StartDate" data-date-format="MM-DD-YYYY" />
                                <div class="input-group-append" id="StartDate" data-target="#StartDate" data-toggle="datetimepicker">
                                    <div class="input-group-text" id="StartDate" placeholder="Masukkan Tanggal Mulai"><i class="fa fa-calendar"></i></div>
                                </div>
                            </div>
                            <span id="span_start_date" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label>Tanggal Selesai Cuti</label>
                            <div class="input-group date" data-target-input="nearest">
                                <input type="text" class="form-control datetimepicker-input" id="EndDate" data-target="#EndDate" data-date-format="MM-DD-YYYY" />
                                <div class="input-group-append" id="EndDate" data-target="#EndDate" data-toggle="datetimepicker">
                                    <div class="input-group-text" id="EndDate" placeholder="Masukkan Tanggal Selasai"><i class="fa fa-calendar"></i></div>
                                </div>
                            </div>
                            <span id="span_end_date" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="control-label">Waktu</label>
                            <input name="Waktu" placeholder="Waktu" id="Waktu" class="form-control" type="text">
                            <span class="help-block"></span>
                        </div>

                        <label class="col-md-12" style="color:red">*Klik Tab untuk pindah field.</label>
                    </div>
                    <div class="card-footer d-flex">
                        <button type="button" id="btnSaveAddUpdate" onclick="add_update_detail()" class="btn btn-primary mx-auto" style="width:35%">Simpan</button>
                        <button type="button" class="btn btn-danger mx-auto" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Select2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/select2/js/select2.full.min.js")"></script>
    <!-- AdminLTE App -->
    <script src="~/AdminLTE/dist/js/adminlte.min.js"></script>
    <!-- AdminLTE for demo purposes -->
    <script src="~/AdminLTE/dist/js/demo.js"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Datepicker -->
    <script src="~/AdminLTE/plugins/bootstrap-datepicker/js/bootstrap-datepicker.min.js"></script>
    <!-- Tempusdominus Bootstrap 4-->
    @*<script src="~/AdminLTE/plugins/moment/moment.min.js"></script>
        <script src="~/AdminLTE/plugins/moment/moment-with-locales.min.js"></script>
        <script src="~/AdminLTE/plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>*@

}

@section AdditionalScript{
    <script type="text/javascript">
        var destination = '@ViewBag.Action';
        var tempId = '@Session["id_karyawan"]';
        var masterPengajuanDetailTable;
        var listDataDtl = [];
        var listDateCollection = [];
        //var karyawanName = "";
        var tglPengajuan = "";
        var dateToday = new Date(); 

        jQuery(document).ready(function ($) {
            if (destination == 'Edit' || destination == 'Detail') {
                $(".card-footer").hide();
                $("#sendToApproval").hide();
                $("#approvalDetail").show();
                $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Action("GetDataDetailPengajuan", "PengajuanCuti")',
                    type: 'POST',
                    data: JSON.stringify({ "id": '@ViewBag.Id' }),
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Get Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (data) {
                        Swal.close();
                        if (data.response.Code == '200') {
                            successInitData(data['data']);
                            if (destination == "Edit") loadDataSelect2();
                        } else {
                            toastr.warning('Gagal memuat data', 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                    }
                });
            } else {
                $(".card-footer").show();
                $("#sendToApproval").show();
                $("#approvalDetail").hide();
                enableDisableTextInput(false);
                loadDataSelect2();
                //getNamaKaryawanById();
                setTanggalPengajuan();
            }
        });

        function successInitData(data) {
            tglPengajuan = data[0].tgl_pengajuan;
            $("#totalDurasiInput").val(data[0].durasi + " hari");
            $("#Keterangan").val(data[0].keterangan_pengajuan);
            $("#AlmSaatCuti").val(data[0].alamat_cuti);
            $("#TelpSaatCuti").val(data[0].notelp_cuti);
            $("#labelDatepicker").text("Lihat Tanggal Cuti");
            $("#JenisCuti").empty().append($("<option/>").val(data[0].id_jenis_pengajuan).text(data[0].nama_pengajuan)).val(data[0].id_jenis_pengajuan);;
            $("#IDApproval").empty().append($("<option/>").val(data[0].id_approval).text(data[0].nama_approval)).val(data[0].id_approval);
            $("#IDKywApproval").empty().append($("<option/>").val(data[0].approved_by).text(data[0].nama_karyawan_approval)).val(data[0].approved_by);

            listDataDtl = data[0].details;
            for (var i = 0; i < listDataDtl.length; i++) {
                listDateCollection.push(listDataDtl[i].start_date.replace("T00:00:00", ""));
            }

            $(document).ready(function () {
                $('#datepicker').datepicker({
                    multidate: true,
                    format: "mm/dd/yyyy",
                    todayHighlight: true,
                    beforeShowDay: function () {
                        return false;
                    }
                });

                $("#datepicker").datepicker('setDates', listDateCollection);
                $('#datepicker').datepicker('setStartDate', new Date());
            });

            if (destination == 'Edit') {
                enableDisableTextInput(false);

            } else if (destination == 'Detail') {
                enableDisableTextInput(true);
            }

            loadDataLogApprovalElm();
        }

        function enableDisableTextInput(enables) {
            $("#JenisCuti").prop('disabled', enables);
            $("#LamaCuti").attr('readonly', enables);
            $("#Keterangan").attr('readonly', enables);
            $("#AlmSaatCuti").attr('readonly', enables);
            $("#TelpSaatCuti").attr('readonly', enables);
            $("#IDApproval").prop('disabled', enables);
            $("#IDKywApproval").prop('disabled', enables);
        }

        function loadDataLogApprovalElm() {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetSpecificDataLogAppReturnElm", "MasterLogApproval")',
                type: 'POST',
                data: JSON.stringify({ "idPengajuan": '@ViewBag.Id'}),
                success: function (data) {
                    if (data.response.Code == '200') {
                        $("#historyApproval").append(data['data']);
                    } else {
                        toastr.warning('Gagal memuat data History Approval', 'Sorry!', { 'timeOut': 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function loadDataDetailTable(destination) {
            if (destination == "Detail") {
                if (!$.fn.DataTable.isDataTable('#dataPengajuanCutiDetail')) {
                    jQuery(document).ready(function ($) {
                        masterPengajuanDetailTable = $("#dataPengajuanCutiDetail").DataTable({
                            "autoWidth": false,
                            "responsive": true,
                            "ajax": {
                                "datatype": 'json',
                                "url": '@Url.Action("GetDataDetailPengajuanById", "PengajuanCuti")/' + '@ViewBag.Id' + '?destination=' + destination,//, new { id = @ViewBag.Id, destination = "Detail" })',
                                "type": 'POST',
                        @*"data": JSON.stringify({"id": '@ViewBag.Id'})*@
                            },
                            "columns": [
                                { "data": "id_pengajuan_detail", "name": "id_pengajuan_detail", "visible": false },
                                { "data": "no", "name": "no" },
                                { "data": "start_date", "name": "start_date" },
                                { "data": "end_date", "name": "end_date" },
                                { "data": "durasi", "name": "durasi" },
                                { "data": "action" },
                            ]
                        });
                    });
                }
                masterPengajuanDetailTable?.column([0]).visible(false, false);
                masterPengajuanDetailTable?.columns.adjust().draw(false);
            } else {
                if (!$.fn.DataTable.isDataTable('#dataPengajuanCutiDetail')) {
                    jQuery(document).ready(function ($) {
                        masterPengajuanDetailTable = $("#dataPengajuanCutiDetail").DataTable({
                            "autoWidth": false,
                            "responsive": true,
                            "data": listDataDtl,
                            "columns": [
                                { "data": "IdPengajuan", "name": "id_pengajuan_detail", "visible": false, "render": function (data, type, full, meta) { return meta.row + 1; } },
                                { "data": "Id", "name": "Id", "render": function (data, type, full, meta) { return meta.row + 1; } },
                                { "data": "StartDate", "name": "StartDate" },
                                { "data": "EndDate", "name": "EndDate" },
                                { "data": "Waktu", "name": "Waktu" },
                                {
                                    "render": function (data, type, full, meta) {
                                        return "<button type='button' id='btnEditDtl' class='btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light' style='margin-right: 5px;' onclick='edit_pengajuandtl(" + meta.row + ")'><i class='fas fa-edit'></i></button>" + "  " +
                                               "<button type='button' id='btnDeleteDtl' class='btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light' onclick='delete_pengajuandtl(" + meta.row + ")'><i class='fa fa-trash-alt'></i></button>";
                                  }
                                }
                            ]
                        });
                    });
                }
            }
        }

        function loadDataDetail(destination) {
            destination == "Detail" ? $("#btnAddDtl").hide() : $("#btnAddDtl").show();
            destination == "Detail" ? $("#btnSubmitData").hide() : $("#btnSubmitData").show();
            $('.nav-tabs a[href="#custom-tabs-two-detail"]').click(function () {
                loadDataDetailTable(destination);
            });
        }

        function getDataJenisCutiById(rowId) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataByID", "MasterJenisPengajuan")',
                type: 'POST',
                data: JSON.stringify({ "id": rowId}),
                success: function (data) {
                    if (data.metaData.code == '200') {
                        $("#JenisCuti").empty().append($("<option/>").val(data.response[0].id_jenis_pengajuan).text(data.response[0].nama_pengajuan)).val(data.response[0].id_jenis_pengajuan);
                    } else {
                        var s = "<option value='-1'></option>";
                        $("#CutiBulanan").html(s);
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function setTanggalPengajuan() {
            var today = new Date();
            var month = today.getMonth() + 1;
            var day = today.getDate();
            var currentDate = (('' + month).length < 2 ? '0' : '') + month +
                            '-' + (('' + day).length < 2 ? '0' : '') + day +
                            '-' + today.getFullYear();
            //$('#TglPengajuan').val(currentDate);
            tglPengajuan = currentDate;
        }

        function show_modal_insertupdatedetail(action) {
            save_method = action;
            if (action == 'ADD') {
                document.getElementById("form-insertupdatedetail").reset();
                $("#insertUpdateDetailModal").text("Tambah Tanggal Cuti");
            } else if (action == 'EDIT') {
                $("#insertUpdateDetailModal").text("Ubah Tanggal Cuti");
            }
            $('.form-group').removeClass('has-error');
            $(".help-block").empty();
            $("#modal_form_insertupdatedetail").modal('show');
        }

        function loadDataSelect2() {
            var idApproval = "";
            var listDetailPct = [];

             $('#JenisCuti').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih Jenis Cuti -',
                width: '100%',
                theme: 'bootstrap4',
                ajax: {
                    url: '@Url.Action("GetDatatableAll", "MasterJenisPengajuan")',
                    type: 'POST',
                    dataType: 'json',
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data['data'], function (item) {
                                if (item.id_jenis_pengajuan != 'CT_02') {
                                    return {
                                        text: item.nama_pengajuan,
                                        id: item.id_jenis_pengajuan
                                    }
                                }
                            })
                        };
                    }
                }
             });

            $('#IDApproval').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Approval -',
                width: '100%',
                theme: 'bootstrap4',
                ajax: {
                    url: '@Url.Action("GetDatatableAll", "MasterApproval")',
                    type: 'POST',
                    dataType: 'json',
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data['data'], function (item) {
                                return {
                                    text: item.nama_approval,
                                    id: item.id_approval
                                }
                            })
                        };
                    }
                }
            });

            $('#IDApproval').on('select2:select', function (e) {
                var idApproval = {
                    "id": $("#IDApproval option:selected").val()
                };

                $('#IDKywApproval').select2({
                    multiple: false,
                    allowClear: true,
                    placeholder: '- Pilih ID Karyawan Approval -',
                    width: '100%',
                    theme: 'bootstrap4',
                    ajax: {
                        contentType: 'application/JSON; charset=utf-8',
                        url: '@Url.Action("GetDataByIdApproval", "MasterKaryawanApproval")',
                        data: JSON.stringify(idApproval),
                        type: 'POST',
                        dataType: 'json',
                        delay: 250,
                        processResults: function (data) {
                            return {
                                results: $.map(data['data'], function (item) {
                                    return {
                                        text: item.nama,
                                        id: item.id_karyawan,
                                        data: item
                                    }
                                })
                            };
                        }
                    }
                });
            });

            $('#IDKywApproval').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Karyawan Approval -',
                width: '100%',
                theme: 'bootstrap4',
            });

            $('#IDApproval').on('select2:unselect', function () {
                $('#IDKywApproval').empty();
                $('#IDKywApproval').select2({
                    multiple: false,
                    allowClear: true,
                    placeholder: '- Pilih ID Karyawan Approval -',
                    width: '100%',
                    theme: 'bootstrap4',
                    data: null
                });
            })

            @*var typeLeaveDay = [
                { id: 0, text: 'Full Day' },
                { id: 1, text: 'Half Day' }
            ];

            $('#LamaCutiChoice').select2({
                autoWidth: false,
                multiple: true,
                allowClear: true,
                placeholder: '- Pilih -',
                width: '100%',
                theme: 'bootstrap4',
                data: typeLeaveDay
            });*@

            @*$('#JenisCuti').on('select2:select', function () {
                if ($('#JenisCuti').val() == 'CT_04') {
                    $('#formFullDay').show(250);
                    $('#formHalfDay').hide();
                } else if ($('#JenisCuti').val() == 'CT_05') {
                    $('#formHalfDay').show(250);
                    $('#formFullDay').hide();
                }
            });*@

            $(document).ready(function () {
                $('#datepicker').datepicker({
                    multidate: true,
                    format: "mm/dd/yyyy",
                    todayHighlight: true
                }).on('changeDate', function (e) {
                    listDateCollection = $("#LeaveDatePicker").val().split(",");
                    $("#totalDurasiInput").val($("#JenisCuti").val() != "CT_05" ? listDateCollection.filter(item => item).length + " hari" : listDateCollection.filter(item => item).length * 0.5 + " hari");
                });
            });
        }

        function delete_pengajuandtl(rowId) {
            if (rowId != null) {
                Swal.fire({
                    title: 'Konfirmasi',
                    text: "Apakah Anda yakin akan menghapus data ini?",
                    type: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Hapus Data',
                    confirmButtonClass: 'btn btn-primary',
                    cancelButtonClass: 'btn btn-danger ml-1',
                    buttonsStyling: false,
                    allowOutsideClick: () => !Swal.isLoading()
                }).then((result) => {
                    if (result.value == true) {
                        listDataDtl.splice(rowId, 1);
                        masterPengajuanDetailTable.clear();
                        masterPengajuanDetailTable.rows.add(listDataDtl).draw();
                    }
                });
            }
        }

        function edit_pengajuandtl(rowId) {
            save_method = "EDIT";
            rowData = rowId;
            $('.form-group').removeClass('has-error');
            $(".help-block").empty();

            if (rowId != null) {
                $("#StartDate").val(masterPengajuanDetailTable.row(rowId).data().start_date);
                $("#EndDate").val(masterPengajuanDetailTable.row(rowId).data().end_date);
                $("#Waktu").val(masterPengajuanDetailTable.row(rowId).data().durasi);

                $("#insertUpdateDetailModal").text("Ubah Tanggal Cuti");
                $("#modal_form_insertupdatedetail").modal('show');
            }
        }

        function add_update_data(save_method) {
            $(".form-group").removeClass('has-error');
            $(".help-block").empty();
            var validate = true;
            var sumDtlDuration = 0;
            $.each(listDataDtl, function () { return sumDtlDuration += parseFloat(this.durasi) || 0;});

            if ($("#JenisCuti").val() == null) {
                $('#spanJenisCuti').text('Jenis Cuti harus diisi');
                $('.err-jenisCuti').css('color: red');
                validate = false;
            }
            @*if ($("#Keterangan").val() == "" || !$("#Keterangan").val().replace(/\s/g, '').length) {
                $('#Keterangan').parent().parent().parent().addClass('has-error');
                $('#Keterangan').next().text('Keterangan harus diisi');
                validate = false;
            }*@
            if ($("#AlmSaatCuti").val() == "" || !$("#AlmSaatCuti").val().replace(/\s/g, '').length) {
                $('#AlmSaatCuti').parent().addClass('has-error');
                $('#AlmSaatCuti').next().text('Alamat Saat Cuti harus diisi');
                validate = false;
            }
            if ($("#TelpSaatCuti").val() == "" || !$("#TelpSaatCuti").val().replace(/\s/g, '').length) {
                $('#TelpSaatCuti').parent().addClass('has-error');
                $('#TelpSaatCuti').next().text('No. Telp. Saat Cuti harus diisi');
                validate = false;
            }
            if ($("#IDApproval").val() == null) {
                $('#spanIdApproval').text('ID Approval harus diisi');
                $('.err-idApproval').css('color: red');
                validate = false;
            }
            if ($("#IDKywApproval").val() == null) {
                $('#spanIdKywApproval').text('ID Karyawan Approval harus diisi');
                $('.err-idKywApproval').css('color: red');
                validate = false;
            }
            if (!listDateCollection.length) {
                toastr.warning("Anda belum memilih Tanggal Cuti.", "Sorry!", { "timeOut" : 5000});
                validate = false;
            }
            if ((parseFloat($("#LamaCuti").val()) || 0) != sumDtlDuration) {
                toastr.warning("Total Durasi di Detail harus sama dengan Lama Cuti", "Sorry!", { "timeOut": 5000 });
                validate = false;
            }
            if (!validate) return;

            var durasi = $("#JenisCuti").val() == "CT_05" ? 0.5 : 1;
            var totalDurasi = listDateCollection.length * durasi;
            var submittedData = {
                "tgl_pengajuan": tglPengajuan,
                "id_karyawan" : tempId,
                "id_jenis_pengajuan" : $("#JenisCuti").val(),
                "durasi": totalDurasi,
                "alamat_cuti" : $("#AlmSaatCuti").val(),
                "notelp_cuti" : $("#TelpSaatCuti").val(),
                "keterangan_pengajuan" : $("#Keterangan").val(),
                "approve_status": "PENDING",
                "created_by" : tempId,
                "created_date" : new Date(),
                "id_approval" : $("#IDApproval").val(),
                "approved_by" : $("#IDKywApproval").val(),
                "details" : []
            };

            for (var i = 0; i < listDateCollection.length; i++) {
                var date = listDateCollection[i].split("/");
                submittedData.details.push({
                    "id_pengajuan": "0",
                    "id_pengajuan_detail": i.toString(),
                    "start_date": new Date(date[0] + "-" + date[1] + "-" + date[2]),
                    "end_date": new Date(date[0] + "-" + date[1] + "-" + date[2]),
                    "durasi": durasi
                });
            }

            if (save_method == 'ADD') {
                url = '@Url.Action("CreateNewPengajuanCuti", "PengajuanCuti")'; //+ submittedData;
                form = "form-insertupdate";
            }
            else if (save_method == 'UPDATE') {
                url = "@Url.Content("~/MasterMenu/UpdateMenu")";
                form = "form-insertupdate";
                var g = masterPengajuanDetailTable.rows().data();
            }

            $.ajax({
                url: '@Url.Content("~/PengajuanCuti/CreateNewPengajuanCuti")',
                contentType: 'application/JSON; charset=utf-8',
                type: 'POST',
                dataType: 'json',
                data: JSON.stringify(submittedData),
                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Saving Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    Swal.close();
                    if (data.response.Code == "200") {
                       @* $("#modal_form_insertupdate").modal('hide');
                        reload_table();*@
                        toastr.success("Data Pengajuan Cuti dengan ID Pengajuan <strong>" + data["data"] + "</strong> berhasil diajukan", "Success!", { "timeOut": 5000 });
                        setTimeout(function () {
                            window.location.href = '@Url.Content("~/PengajuanCuti/Index")';
                        }, 1000);
                        //window.location.href = '@Url.Content("~/PengajuanCuti/Index")';
                    } else {
                        toastr.warning(data.response.Message, "Sorry!", { "timeOut": 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    Swal.close();
                    $('#btnSaveAddUpdate').text('Save'); //change button text
                    $('#btnSaveAddUpdate').attr('disabled', false);
                    toastr.error("Gagal submit data pengajuan.", 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function validateDataDtl(item, rowData) {
            if (save_method == "ADD") {
                for (var i = 0; i < listDataDtl.length; i++) {
                    if (listDataDtl[i].start_date == item.start_date) return "Tanggal Mulai sudah ada";
                    if (listDataDtl[i].end_date == item.end_date) return "Tanggal Selesai sudah ada";
                }
            } else if (save_method == "EDIT") {
                for (var i = 0; i < listDataDtl.length; i++) {
                    if (i != rowData) {
                        if (listDataDtl[i].start_date == item.start_date) return "Tanggal Mulai sudah ada";
                        if (listDataDtl[i].end_date == item.end_date) return "Tanggal Selesai sudah ada";
                    }
                }
            }
            return "Success";
        }

        function add_update_detail() {
            var validate = "Success";
            var _validate = true;
            var itemDtl = {
                "start_date": $("#StartDate").val(),
                "end_date": $("#EndDate").val(),
                "durasi": $("#Waktu").val()
            };

            $('.form-group').removeClass('has-error');
            $(".help-block").empty();

            if ($("#StartDate").val() == "" || !$("#StartDate").val().replace(/\s/g, '').length) {
                $('#StartDate').parent().addClass('has-error');
                $('#span_start_date').text('Tanggal Mulai harus diisi');
                _validate = false;
            }
            if ($("#EndDate").val() == "" || !$("#EndDate").val().replace(/\s/g, '').length) {
                $('#EndDate').parent().addClass('has-error');
                $('#span_end_date').text('Tanggal Selesai harus diisi');
                _validate = false;
            }
            if ($("#Waktu").val() == "" || !$("#Waktu").val().replace(/\s/g, '').length) {
                $('#Waktu').parent().addClass('has-error');
                $('#Waktu').next().text('Waktu harus diisi');
                _validate = false;
            }
            if (!_validate) return;

            if (save_method == "ADD") {
                if (listDataDtl.length > 0) validate = validateDataDtl(itemDtl, 0);

                if (validate == "Success") {
                    listDataDtl.push(itemDtl);

                }
                else {
                    $("#modal_form_insertupdatedetail").modal('hide');
                    return toastr.warning("Gagal menambahkan data: " + validate, "Sorry!", { "timeOut": 5000 });
                }
            }
            else if (save_method == "EDIT") {
                if (listDataDtl.length > 0) validate = validateDataDtl(itemDtl, rowData);

                if (validate == "Success") {
                    listDataDtl[rowData].start_date = itemDtl.start_date;
                    listDataDtl[rowData].end_date = itemDtl.end_date;
                    listDataDtl[rowData].durasi = itemDtl.durasi;
                }
                else {
                    $("#modal_form_insertupdatedetail").modal('hide');
                    return toastr.warning("Gagal menambahkan data: " + validate, "Sorry!", { "timeOut": 5000 });
                }
            }

            masterPengajuanDetailTable.clear();
            masterPengajuanDetailTable.rows.add(listDataDtl).draw();
            $("#modal_form_insertupdatedetail").modal('hide');
        }
    </script>
}
